import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { IgcPropertyEditorDescriptionObject } from "./igc-property-editor-description-object";
import { IgcPropertyEditorDescriptionObjectCollection } from "./igc-property-editor-description-object-collection";
import { IgcPropertyEditorPropertyDescriptionCollection } from "./igc-property-editor-property-description-collection";
import { IgcPropertyEditorPropertyDescriptionButtonClickEventArgs } from "./igc-property-editor-property-description-button-click-event-args";
import { IgcPropertyEditorPropertyDescriptionChangedEventArgs } from "./igc-property-editor-property-description-changed-event-args";
import { IgcPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./igc-property-editor-property-description-target-property-updating-event-args";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { TypeRegistrar } from "igniteui-webcomponents-core";
import { NamePatcher, getAllPropertyNames, fromSpinal, toSpinal, ensureEnum, enumToString, ensureBool, initializePropertiesFromCss } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { PropertyEditorDescriptionObjectCollection as PropertyEditorDescriptionObjectCollection_internal } from "./PropertyEditorDescriptionObjectCollection";
import { PropertyEditorDescriptionObject } from "./PropertyEditorDescriptionObject";
import { SyncableObservableCollection$1 } from "igniteui-webcomponents-core";
import { PropertyEditorPropertyDescriptionCollection as PropertyEditorPropertyDescriptionCollection_internal } from "./PropertyEditorPropertyDescriptionCollection";
export let IgcPropertyEditorPropertyDescriptionComponent = /*@__PURE__*/ (() => {
    class IgcPropertyEditorPropertyDescriptionComponent extends IgcHTMLElement {
        createImplementation() {
            return new PropertyEditorPropertyDescription();
        }
        /**
         * @hidden
         */
        get i() {
            return this._implementation;
        } /**
                                     * @hidden
                                     */
        static _createFromInternal(internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = "Igc" + name + "Component";
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
        onImplementationCreated() {
        }
        constructor() {
            super();
            this._settingAttributes = false;
            this._attached = false;
            this._queuedSetAttributes = [];
            this._updatingFromAttribute = false;
            this._complexValues = null;
            this._properties = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._buttonClicked = null;
            this._buttonClicked_wrapped = null;
            this._changed = null;
            this._changed_wrapped = null;
            this._targetPropertyUpdating = null;
            this._targetPropertyUpdating_wrapped = null;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        _enqueueSetAttribute(attrName, attrValue) {
            this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
        }
        _flushQueuedAttributes() {
            this._settingAttributes = true;
            for (let i = 0; i < this._queuedSetAttributes.length; i++) {
                this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
            }
            this._settingAttributes = false;
            this._queuedSetAttributes.length = 0;
        }
        _a(attrName, attrValue) {
            if (this._updatingFromAttribute) {
                return;
            }
            if (attrValue) {
                attrValue = attrValue.toString();
            }
            this._settingAttributes = true;
            attrName = toSpinal(attrName);
            if (this._attached) {
                this.setAttribute(attrName, attrValue);
            }
            else {
                this._enqueueSetAttribute(attrName, attrValue);
            }
            this._settingAttributes = false;
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcPropertyEditorPropertyDescriptionComponent._observedAttributesIgcPropertyEditorPropertyDescriptionComponent == null) {
                let names = getAllPropertyNames(IgcPropertyEditorPropertyDescriptionComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcPropertyEditorPropertyDescriptionComponent._observedAttributesIgcPropertyEditorPropertyDescriptionComponent = names;
            }
            return IgcPropertyEditorPropertyDescriptionComponent._observedAttributesIgcPropertyEditorPropertyDescriptionComponent;
        }
        attributeChangedCallback(name, oldValue, newValue) {
            if (this._settingAttributes) {
                return;
            }
            let setName = fromSpinal(name);
            this._updatingFromAttribute = true;
            this[setName] = newValue;
            this._updatingFromAttribute = false;
        }
        static register() {
            if (!IgcPropertyEditorPropertyDescriptionComponent._isElementRegistered) {
                IgcPropertyEditorPropertyDescriptionComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcPropertyEditorPropertyDescriptionComponent.htmlTagName, IgcPropertyEditorPropertyDescriptionComponent);
            }
        }
        get propertyPath() {
            return this.i.an;
        }
        set propertyPath(v) {
            this.i.an = v;
        }
        get label() {
            return this.i.al;
        }
        set label(v) {
            this.i.al = v;
        }
        get valueType() {
            return this.i.p;
        }
        set valueType(v) {
            this.i.p = ensureEnum(PropertyEditorValueType_$type, v);
            this._a("valueType", enumToString(PropertyEditorValueType_$type, this.i.p));
        }
        get propertyDescriptionType() {
            return this.i.am;
        }
        set propertyDescriptionType(v) {
            this.i.am = v;
        }
        get shouldOverrideDefaultEditor() {
            return this.i.s;
        }
        set shouldOverrideDefaultEditor(v) {
            this.i.s = ensureBool(v);
            this._a("shouldOverrideDefaultEditor", this.i.s);
        }
        get elementDescriptionType() {
            return this.i.ak;
        }
        set elementDescriptionType(v) {
            this.i.ak = v;
        }
        get dropDownNames() {
            return this.i.c;
        }
        set dropDownNames(v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                const re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.c = v;
        }
        get dropDownValues() {
            return this.i.d;
        }
        set dropDownValues(v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                const re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.d = v;
        }
        get primitiveValue() {
            return this.i.af;
        }
        set primitiveValue(v) {
            this.i.af = v;
        }
        get min() {
            return this.i.ab;
        }
        set min(v) {
            this.i.ab = +v;
            this._a("min", this.i.ab);
        }
        get editorWidth() {
            return this.i.y;
        }
        set editorWidth(v) {
            this.i.y = +v;
            this._a("editorWidth", this.i.y);
        }
        get labelWidth() {
            return this.i.z;
        }
        set labelWidth(v) {
            this.i.z = +v;
            this._a("labelWidth", this.i.z);
        }
        get max() {
            return this.i.aa;
        }
        set max(v) {
            this.i.aa = +v;
            this._a("max", this.i.aa);
        }
        get step() {
            return this.i.ac;
        }
        set step(v) {
            this.i.ac = +v;
            this._a("step", this.i.ac);
        }
        get complexValue() {
            const r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                let e = new IgcPropertyEditorDescriptionObject();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        }
        set complexValue(v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        }
        get complexValues() {
            if (this._complexValues === null) {
                let coll = new IgcPropertyEditorDescriptionObjectCollection();
                let innerColl = this.i.i;
                if (!innerColl) {
                    innerColl = new PropertyEditorDescriptionObjectCollection_internal();
                }
                this._complexValues = coll._fromInner(innerColl);
                this.i.i = innerColl;
            }
            return this._complexValues;
        }
        set complexValues(v) {
            if (this._complexValues !== null) {
                this._complexValues._setSyncTarget(null);
                this._complexValues = null;
            }
            let coll = new IgcPropertyEditorDescriptionObjectCollection();
            this._complexValues = coll._fromOuter(v);
            let syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
            let innerColl = this.i.i;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._complexValues._setSyncTarget(syncColl);
            this.i.i = innerColl;
        }
        get properties() {
            if (this._properties === null) {
                let coll = new IgcPropertyEditorPropertyDescriptionCollection();
                let innerColl = this.i.m;
                if (!innerColl) {
                    innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
                }
                this._properties = coll._fromInner(innerColl);
                this.i.m = innerColl;
            }
            return this._properties;
        }
        set properties(v) {
            if (this._properties !== null) {
                this._properties._setSyncTarget(null);
                this._properties = null;
            }
            let coll = new IgcPropertyEditorPropertyDescriptionCollection();
            this._properties = coll._fromOuter(v);
            let syncColl = new SyncableObservableCollection$1(PropertyEditorPropertyDescription.$type);
            let innerColl = this.i.m;
            if (!innerColl) {
                innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._properties._setSyncTarget(syncColl);
            this.i.m = innerColl;
        }
        findByName(name) {
            if (this.findEphemera) {
                if (name && name.indexOf("@@e:") == 0) {
                    return this.findEphemera(name);
                }
            }
            if (this.complexValue && this.complexValue.name && this.complexValue.name == name) {
                return this.complexValue;
            }
            if (this.complexValues != null && this.complexValues.findByName && this.complexValues.findByName(name)) {
                return this.complexValues.findByName(name);
            }
            if (this.properties != null && this.properties.findByName && this.properties.findByName(name)) {
                return this.properties.findByName(name);
            }
            return null;
        }
        get hasUserValues() {
            return this._hasUserValues;
        }
        __m(propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        }
        _styling(container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            let genericPrefix = "";
            let typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = toSpinal("PropertyEditorPropertyDescriptionComponent");
            let additionalPrefixes = [];
            let prefix = toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            let b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                let basePrefix = toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                let parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                let parentPrefix = toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        }
        get buttonClicked() {
            return this._buttonClicked;
        }
        set buttonClicked(ev) {
            if (this._buttonClicked_wrapped !== null) {
                this.i.buttonClicked = delegateRemove(this.i.buttonClicked, this._buttonClicked_wrapped);
                this._buttonClicked_wrapped = null;
                this._buttonClicked = null;
            }
            this._buttonClicked = ev;
            this._buttonClicked_wrapped = (o, e) => {
                let outerArgs = new IgcPropertyEditorPropertyDescriptionButtonClickEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeButtonClicked) {
                    this.beforeButtonClicked(this, outerArgs);
                }
                if (this._buttonClicked) {
                    this._buttonClicked(this, outerArgs);
                }
            };
            this.i.buttonClicked = delegateCombine(this.i.buttonClicked, this._buttonClicked_wrapped);
            ;
        }
        get changed() {
            return this._changed;
        }
        set changed(ev) {
            if (this._changed_wrapped !== null) {
                this.i.changed = delegateRemove(this.i.changed, this._changed_wrapped);
                this._changed_wrapped = null;
                this._changed = null;
            }
            this._changed = ev;
            this._changed_wrapped = (o, e) => {
                let outerArgs = new IgcPropertyEditorPropertyDescriptionChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeChanged) {
                    this.beforeChanged(this, outerArgs);
                }
                if (this._changed) {
                    this._changed(this, outerArgs);
                }
            };
            this.i.changed = delegateCombine(this.i.changed, this._changed_wrapped);
            ;
        }
        get targetPropertyUpdating() {
            return this._targetPropertyUpdating;
        }
        set targetPropertyUpdating(ev) {
            if (this._targetPropertyUpdating_wrapped !== null) {
                this.i.targetPropertyUpdating = delegateRemove(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
                this._targetPropertyUpdating_wrapped = null;
                this._targetPropertyUpdating = null;
            }
            this._targetPropertyUpdating = ev;
            this._targetPropertyUpdating_wrapped = (o, e) => {
                let outerArgs = new IgcPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeTargetPropertyUpdating) {
                    this.beforeTargetPropertyUpdating(this, outerArgs);
                }
                if (this._targetPropertyUpdating) {
                    this._targetPropertyUpdating(this, outerArgs);
                }
            };
            this.i.targetPropertyUpdating = delegateCombine(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
            ;
        }
    }
    IgcPropertyEditorPropertyDescriptionComponent._observedAttributesIgcPropertyEditorPropertyDescriptionComponent = null;
    IgcPropertyEditorPropertyDescriptionComponent.htmlTagName = "igc-property-editor-property-description";
    IgcPropertyEditorPropertyDescriptionComponent._isElementRegistered = false;
    return IgcPropertyEditorPropertyDescriptionComponent;
})();
