import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { getAllPropertyNames, toSpinal, ensureBool } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionCheckboxComponent = /*@__PURE__*/ (() => {
    class IgcToolActionCheckboxComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionCheckbox();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent == null) {
                let names = getAllPropertyNames(IgcToolActionCheckboxComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent = names;
            }
            return IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent;
        }
        static register() {
            if (!IgcToolActionCheckboxComponent._isElementRegistered) {
                IgcToolActionCheckboxComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionCheckboxComponent.htmlTagName, IgcToolActionCheckboxComponent);
            }
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get isChecked() {
            return this.i.e4;
        }
        set isChecked(v) {
            this.i.e4 = ensureBool(v);
            this._a("isChecked", this.i.e4);
        }
        fromInfo(info) {
            this.i.dp(info);
        }
    }
    IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent = null;
    IgcToolActionCheckboxComponent.htmlTagName = "igc-tool-action-checkbox";
    IgcToolActionCheckboxComponent._isElementRegistered = false;
    return IgcToolActionCheckboxComponent;
})();
