import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { ToolAction as ToolAction_internal } from './ToolAction';
import { IgcToolActionComponent as IgcToolActionComponent } from './igc-tool-action-component';
export class IgcToolActionCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcToolActionComponent.$type) {
            IgcToolActionComponent.$type = markType(IgcToolActionComponent, "IgcToolActionComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcToolActionComponent.$type) {
            IgcToolActionComponent.$type = markType(IgcToolActionComponent, "IgcToolActionComponent");
        }
        let coll = new SyncableObservableCollection$2(IgcToolActionComponent.$type, ToolAction_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgcToolActionComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
