import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionRadio } from "./ToolActionRadio";
import { getAllPropertyNames, toSpinal, ensureBool } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionRadioComponent = /*@__PURE__*/ (() => {
    class IgcToolActionRadioComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionRadio();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent == null) {
                let names = getAllPropertyNames(IgcToolActionRadioComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent = names;
            }
            return IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent;
        }
        static register() {
            if (!IgcToolActionRadioComponent._isElementRegistered) {
                IgcToolActionRadioComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionRadioComponent.htmlTagName, IgcToolActionRadioComponent);
            }
        }
        /**
         * Gets or sets the channel this radio button belongs to.
        */
        get channel() {
            return this.i.e6;
        }
        set channel(v) {
            this.i.e6 = v;
        }
        /**
         * Gets or sets if the tool action is checked.
        */
        get isChecked() {
            return this.i.e4;
        }
        set isChecked(v) {
            this.i.e4 = ensureBool(v);
            this._a("isChecked", this.i.e4);
        }
        fromInfo(info) {
            this.i.dp(info);
        }
    }
    IgcToolActionRadioComponent._observedAttributesIgcToolActionRadioComponent = null;
    IgcToolActionRadioComponent.htmlTagName = "igc-tool-action-radio";
    IgcToolActionRadioComponent._isElementRegistered = false;
    return IgcToolActionRadioComponent;
})();
