import { __extends } from "tslib";
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, toSpinal, enumToString, getAllPropertyNames, fromSpinal } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { WebComponentRenderer } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { ListPanel } from "./ListPanel";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcListPanelTemplateItemUpdatingEventArgs } from './igc-list-panel-template-item-updating-event-args';
import { ListPanelOrientation_$type } from './ListPanelOrientation';
import { IgcListPanelContentRefreshedEventArgs } from './igc-list-panel-content-refreshed-event-args';
import { IgcListPanelTemplateWidthRequestedEventArgs } from './igc-list-panel-template-width-requested-event-args';
import { IgcListPanelTemplateHeightRequestedEventArgs } from './igc-list-panel-template-height-requested-event-args';
import { LocalDataSource } from "igniteui-webcomponents-core";
var IgcListPanelComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcListPanelComponent, _super);
    function IgcListPanelComponent() {
        var _this = _super.call(this) || this;
        _this._implementation = null;
        _this._disconnected = false;
        _this._dataSource = null;
        _this._settingAttributes = false;
        _this._attached = false;
        _this._queuedSetAttributes = [];
        _this._updatingFromAttribute = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._contentRefreshed = null;
        _this._contentRefreshed_wrapped = null;
        _this._rowUpdating = null;
        _this._rowUpdating_wrapped = null;
        _this._itemWidthRequested = null;
        _this._itemWidthRequested_wrapped = null;
        _this._itemHeightRequested = null;
        _this._itemHeightRequested_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, {});
        _this._webComponentWrapper = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._webComponentWrapper);
        _this._webComponentWrapper.setStyleProperty("display", "block");
        _this._webComponentWrapper.setStyleProperty("width", "100%");
        _this._webComponentWrapper.setStyleProperty("height", "100%");
        _this.i.externalListPanel = _this;
        _this.i.provideContainer(_this._webComponentRenderer);
        _this.i.notifySizeChanged();
        _this._webComponentRenderer.addSizeWatcher(function () {
            _this.i.notifySizeChanged();
        });
        return _this;
    }
    Object.defineProperty(IgcListPanelComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
            this.i.notifySizeChanged();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
            this.i.notifySizeChanged();
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype.createLocalDataSource = function (itemsSource) {
        var lds = new LocalDataSource();
        lds.dataSource = itemsSource;
        return lds;
    };
    IgcListPanelComponent.prototype.onContentSizeChanged = function () {
    };
    // supports angular themes or custom properties set in CSS
    IgcListPanelComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcListPanelComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcListPanelComponent.prototype.createImplementation = function () {
        return new ListPanel();
    };
    Object.defineProperty(IgcListPanelComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcListPanelComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-list-panel");
        this.classList.add("igc-list-panel");
        var rootWrapper = this._webComponentRenderer.rootWrapper;
        var rootElement = rootWrapper.getNativeElement();
        this.appendChild(rootElement);
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcListPanelComponent.prototype.afterContentInit = function () {
        this.i.notifySizeChanged();
    };
    Object.defineProperty(IgcListPanelComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            if (this._implementation != null) {
                this._implementation.itemsSource = this._dataSource;
            }
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype._enqueueSetAttribute = function (attrName, attrValue) {
        this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
    };
    IgcListPanelComponent.prototype._flushQueuedAttributes = function () {
        this._settingAttributes = true;
        for (var i = 0; i < this._queuedSetAttributes.length; i++) {
            this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
        }
        this._settingAttributes = false;
        this._queuedSetAttributes.length = 0;
    };
    IgcListPanelComponent.prototype._a = function (attrName, attrValue) {
        if (this._updatingFromAttribute) {
            return;
        }
        if (attrValue) {
            attrValue = attrValue.toString();
        }
        this._settingAttributes = true;
        attrName = toSpinal(attrName);
        if (this._attached) {
            this.setAttribute(attrName, attrValue);
        }
        else {
            this._enqueueSetAttribute(attrName, attrValue);
        }
        this._settingAttributes = false;
    };
    Object.defineProperty(IgcListPanelComponent, "observedAttributes", {
        get: function () {
            if (IgcListPanelComponent._observedAttributesIgcListPanelComponent == null) {
                var names = getAllPropertyNames(IgcListPanelComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcListPanelComponent._observedAttributesIgcListPanelComponent = names;
            }
            return IgcListPanelComponent._observedAttributesIgcListPanelComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (this._settingAttributes) {
            return;
        }
        var setName = fromSpinal(name);
        this._updatingFromAttribute = true;
        this[setName] = newValue;
        this._updatingFromAttribute = false;
    };
    IgcListPanelComponent.register = function () {
        if (!IgcListPanelComponent._isElementRegistered) {
            IgcListPanelComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcListPanelComponent.htmlTagName, IgcListPanelComponent);
        }
    };
    Object.defineProperty(IgcListPanelComponent.prototype, "rowHeight", {
        /**
     * Gets or Sets the property name that contains the values.
    */
        get: function () {
            return this.i.a7;
        },
        set: function (v) {
            this.i.a7 = +v;
            this._a("rowHeight", this.i.a7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "actualRowHeight", {
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = +v;
            this._a("actualRowHeight", this.i.av);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "cellTextStyle", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: function () {
            if (this.i.s == null) {
                return null;
            }
            return this.i.s.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.s = fi;
            this._a("cellTextStyle", this.i.s != null ? this.i.s.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "hasUnevenSizes", {
        get: function () {
            return this.i.ah;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return brushToString(this.i.cs);
        },
        set: function (v) {
            this.i.cs = stringToBrush(v);
            this._a("backgroundColor", brushToString(this.i.cs));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "orientation", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureEnum(ListPanelOrientation_$type, v);
            this._a("orientation", enumToString(ListPanelOrientation_$type, this.i.k));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "isCustomRowHeightEnabled", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = ensureBool(v);
            this._a("isCustomRowHeightEnabled", this.i.ai);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the component.
        */
        get: function () {
            return brushToString(this.i.cv);
        },
        set: function (v) {
            this.i.cv = stringToBrush(v);
            this._a("textColor", brushToString(this.i.cv));
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgcListPanelComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgcListPanelComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ListPanelComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Gets the last visible index in the grid.

*/
    IgcListPanelComponent.prototype.getLastVisibleIndex = function () {
        var iv = this.i.a4();
        return (iv);
    };
    /**
     * Gets the first visible index in the grid.
    
    */
    IgcListPanelComponent.prototype.getFirstVisibleIndex = function () {
        var iv = this.i.a3();
        return (iv);
    };
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    IgcListPanelComponent.prototype.invalidateVisibleItems = function () {
        this.i.by();
    };
    IgcListPanelComponent.prototype.notifySetItem = function (index, oldItem, newItem) {
        this.i.b4(index, oldItem, newItem);
    };
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    IgcListPanelComponent.prototype.notifyClearItems = function () {
        this.i.b1();
    };
    IgcListPanelComponent.prototype.notifyInsertItem = function (index, newItem) {
        this.i.b2(index, newItem);
    };
    IgcListPanelComponent.prototype.notifyRemoveItem = function (index, oldItem) {
        this.i.b3(index, oldItem);
    };
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    IgcListPanelComponent.prototype.dataIndexOfItem = function (item) {
        var iv = this.i.a1(item);
        return (iv);
    };
    IgcListPanelComponent.prototype.dataIndexOfPrimaryKey = function (key) {
        var iv = this.i.a2(key);
        return (iv);
    };
    Object.defineProperty(IgcListPanelComponent.prototype, "contentRefreshed", {
        get: function () {
            return this._contentRefreshed;
        },
        set: function (ev) {
            var _this = this;
            if (this._contentRefreshed_wrapped !== null) {
                this.i.contentRefreshed = delegateRemove(this.i.contentRefreshed, this._contentRefreshed_wrapped);
                this._contentRefreshed_wrapped = null;
                this._contentRefreshed = null;
            }
            this._contentRefreshed = ev;
            this._contentRefreshed_wrapped = function (o, e) {
                var outerArgs = new IgcListPanelContentRefreshedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeContentRefreshed) {
                    _this.beforeContentRefreshed(_this, outerArgs);
                }
                if (_this._contentRefreshed) {
                    _this._contentRefreshed(_this, outerArgs);
                }
            };
            this.i.contentRefreshed = delegateCombine(this.i.contentRefreshed, this._contentRefreshed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "rowUpdating", {
        get: function () {
            return this._rowUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._rowUpdating_wrapped !== null) {
                this.i.rowUpdating = delegateRemove(this.i.rowUpdating, this._rowUpdating_wrapped);
                this._rowUpdating_wrapped = null;
                this._rowUpdating = null;
            }
            this._rowUpdating = ev;
            this._rowUpdating_wrapped = function (o, e) {
                var outerArgs = new IgcListPanelTemplateItemUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRowUpdating) {
                    _this.beforeRowUpdating(_this, outerArgs);
                }
                if (_this._rowUpdating) {
                    _this._rowUpdating(_this, outerArgs);
                }
            };
            this.i.rowUpdating = delegateCombine(this.i.rowUpdating, this._rowUpdating_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "itemWidthRequested", {
        get: function () {
            return this._itemWidthRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemWidthRequested_wrapped !== null) {
                this.i.itemWidthRequested = delegateRemove(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
                this._itemWidthRequested_wrapped = null;
                this._itemWidthRequested = null;
            }
            this._itemWidthRequested = ev;
            this._itemWidthRequested_wrapped = function (o, e) {
                var outerArgs = new IgcListPanelTemplateWidthRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemWidthRequested) {
                    _this.beforeItemWidthRequested(_this, outerArgs);
                }
                if (_this._itemWidthRequested) {
                    _this._itemWidthRequested(_this, outerArgs);
                }
            };
            this.i.itemWidthRequested = delegateCombine(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcListPanelComponent.prototype, "itemHeightRequested", {
        get: function () {
            return this._itemHeightRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemHeightRequested_wrapped !== null) {
                this.i.itemHeightRequested = delegateRemove(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
                this._itemHeightRequested_wrapped = null;
                this._itemHeightRequested = null;
            }
            this._itemHeightRequested = ev;
            this._itemHeightRequested_wrapped = function (o, e) {
                var outerArgs = new IgcListPanelTemplateHeightRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemHeightRequested) {
                    _this.beforeItemHeightRequested(_this, outerArgs);
                }
                if (_this._itemHeightRequested) {
                    _this._itemHeightRequested(_this, outerArgs);
                }
            };
            this.i.itemHeightRequested = delegateCombine(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcListPanelComponent._observedAttributesIgcListPanelComponent = null;
    IgcListPanelComponent.htmlTagName = "igc-list-panel";
    IgcListPanelComponent._isElementRegistered = false;
    return IgcListPanelComponent;
}(IgcHTMLElement));
export { IgcListPanelComponent };
