import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionType_$type } from "igniteui-webcomponents-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from "./ToolActionEventDetail";
import { ensureEnum, ensureBool } from "igniteui-webcomponents-core";
var IgcToolActionEventDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgcToolActionEventDetail() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgcToolActionEventDetail.prototype.createImplementation = function () {
        return new ToolActionEventDetail_internal();
    };
    Object.defineProperty(IgcToolActionEventDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionEventDetail.prototype.onImplementationCreated = function () {
    };
    IgcToolActionEventDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgcToolActionEventDetail.prototype, "action", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcToolActionComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "actionType", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(ToolActionType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "isModified", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "boolValue", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "numberValue", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "dateTimeValue", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionEventDetail.prototype, "untypedValue", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionEventDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.action && this.action.name && this.action.name == name) {
            return this.action;
        }
        return null;
    };
    return IgcToolActionEventDetail;
}());
export { IgcToolActionEventDetail };
