import { __extends, __values } from "tslib";
import { brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, toSpinal, getAllPropertyNames, fromSpinal } from "igniteui-webcomponents-core";
import { WebComponentRenderer, PortalManager } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { XExpansionPanel } from "./XExpansionPanel";
import { IgcOnExpandedEventArgs } from './igc-on-expanded-event-args';
import { IgcOnCollapsedEventArgs } from './igc-on-collapsed-event-args';
import { IgcHTMLElement } from "igniteui-webcomponents-core";
var IgcXExpansionPanelComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcXExpansionPanelComponent, _super);
    function IgcXExpansionPanelComponent() {
        var _this = _super.call(this) || this;
        _this._implementation = null;
        _this._disconnected = false;
        _this._settingAttributes = false;
        _this._attached = false;
        _this._queuedSetAttributes = [];
        _this._updatingFromAttribute = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._onCollapsed = null;
        _this._onCollapsed_wrapped = null;
        _this._onExpanded = null;
        _this._onExpanded_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._portalManager = new PortalManager("iconContent");
        _this._webComponentRenderer = new WebComponentRenderer(_this, document, true, {}, _this._portalManager);
        _this._mainDiv = _this._webComponentRenderer.createElement("div");
        _this._webComponentRenderer.updateRoot(_this._mainDiv);
        var header = _this._webComponentRenderer.createElement("div");
        header.setAttribute("key", "expansionPanelHeaderArea");
        var contentOuter = _this._webComponentRenderer.createElement("div");
        contentOuter.setAttribute("key", "expansionPanelContentAreaOuter");
        var contentInner = _this._webComponentRenderer.createElement("div");
        contentInner.setAttribute("key", "expansionPanelContentAreaInner");
        contentOuter.append(contentInner);
        _this._mainDiv.append(header);
        _this._mainDiv.append(contentOuter);
        var mut = new MutationObserver(function (list) {
            var e_1, _b;
            try {
                for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                    var mutation = list_1_1.value;
                    if (mutation.type == 'childList') {
                        for (var i = 0; i < _this.childNodes.length; i++) {
                            var child = _this.childNodes[i];
                            if (child != _this._mainDiv.getNativeElement() &&
                                child !== header.getNativeElement() &&
                                child !== contentOuter.getNativeElement() &&
                                child !== contentInner.getNativeElement()) {
                                //TODO: maybe hide and clone this, allow for dynamic removal of content, etc.
                                child.remove();
                                contentInner.append(_this._webComponentRenderer.getWrapper(child));
                            }
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (list_1_1 && !list_1_1.done && (_b = list_1.return))
                        _b.call(list_1);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        });
        mut.observe(_this, {
            childList: true
        });
        _this.i.provideRenderer(_this._webComponentRenderer);
        _this.i.provideHeader(_this._webComponentRenderer.getWrapper(header));
        _this.i.provideContentAreaOuter(_this._webComponentRenderer.getWrapper(contentOuter));
        _this.i.provideContentAreaInner(_this._webComponentRenderer.getWrapper(contentInner));
        return _this;
    }
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
        },
        enumerable: false,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    IgcXExpansionPanelComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcXExpansionPanelComponent.prototype.destroy = function () {
        this._implementation.destroy();
        this._webComponentRenderer.destroy();
    };
    IgcXExpansionPanelComponent.prototype.createImplementation = function () {
        return new XExpansionPanel();
    };
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcXExpansionPanelComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
    };
    IgcXExpansionPanelComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            return;
        }
        this.classList.add("ig-expansion-panel");
        this.classList.add("igr-expansion-panel");
        this.appendChild(this._mainDiv.getNativeElement());
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcXExpansionPanelComponent.prototype.afterContentInit = function () {
    };
    IgcXExpansionPanelComponent.prototype._enqueueSetAttribute = function (attrName, attrValue) {
        this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
    };
    IgcXExpansionPanelComponent.prototype._flushQueuedAttributes = function () {
        this._settingAttributes = true;
        for (var i = 0; i < this._queuedSetAttributes.length; i++) {
            this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
        }
        this._settingAttributes = false;
        this._queuedSetAttributes.length = 0;
    };
    IgcXExpansionPanelComponent.prototype._a = function (attrName, attrValue) {
        if (this._updatingFromAttribute) {
            return;
        }
        if (attrValue) {
            attrValue = attrValue.toString();
        }
        this._settingAttributes = true;
        attrName = toSpinal(attrName);
        if (this._attached) {
            this.setAttribute(attrName, attrValue);
        }
        else {
            this._enqueueSetAttribute(attrName, attrValue);
        }
        this._settingAttributes = false;
    };
    Object.defineProperty(IgcXExpansionPanelComponent, "observedAttributes", {
        get: function () {
            if (IgcXExpansionPanelComponent._observedAttributesIgcXExpansionPanelComponent == null) {
                var names = getAllPropertyNames(IgcXExpansionPanelComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcXExpansionPanelComponent._observedAttributesIgcXExpansionPanelComponent = names;
            }
            return IgcXExpansionPanelComponent._observedAttributesIgcXExpansionPanelComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcXExpansionPanelComponent.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (this._settingAttributes) {
            return;
        }
        var setName = fromSpinal(name);
        this._updatingFromAttribute = true;
        this[setName] = newValue;
        this._updatingFromAttribute = false;
    };
    IgcXExpansionPanelComponent.register = function () {
        if (!IgcXExpansionPanelComponent._isElementRegistered) {
            IgcXExpansionPanelComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcXExpansionPanelComponent.htmlTagName, IgcXExpansionPanelComponent);
        }
    };
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "caption", {
        /**
     * Gets / sets the caption to display in the header area.
    */
        get: function () {
            return this.i.ab;
        },
        set: function (v) {
            this.i.ab = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "captionTextColor", {
        /**
         * Gets or sets the color to use for the header caption text.
        */
        get: function () {
            return brushToString(this.i.bq);
        },
        set: function (v) {
            this.i.bq = stringToBrush(v);
            this._a("captionTextColor", brushToString(this.i.bq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualCaptionTextColor", {
        /**
         * Gets or sets the color to use for the actual header caption text.
        */
        get: function () {
            return brushToString(this.i.bj);
        },
        set: function (v) {
            this.i.bj = stringToBrush(v);
            this._a("actualCaptionTextColor", brushToString(this.i.bj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "captionCollapsedTextColor", {
        /**
         * Gets or sets the color to use for the header caption text when the panel is collapsed.
        */
        get: function () {
            return brushToString(this.i.bo);
        },
        set: function (v) {
            this.i.bo = stringToBrush(v);
            this._a("captionCollapsedTextColor", brushToString(this.i.bo));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "captionExpandedTextColor", {
        /**
         * Gets or sets the color to use for the header caption text when the panel is expanded.
        */
        get: function () {
            return brushToString(this.i.bp);
        },
        set: function (v) {
            this.i.bp = stringToBrush(v);
            this._a("captionExpandedTextColor", brushToString(this.i.bp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "description", {
        /**
         * Gets / sets the description to display in the header area.
        */
        get: function () {
            return this.i.ah;
        },
        set: function (v) {
            this.i.ah = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "descriptionTextColor", {
        /**
         * Gets or sets the color to use for the header description text.
        */
        get: function () {
            return brushToString(this.i.bz);
        },
        set: function (v) {
            this.i.bz = stringToBrush(v);
            this._a("descriptionTextColor", brushToString(this.i.bz));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualDescriptionTextColor", {
        /**
         * Gets or sets the color to use for the actual header description text.
        */
        get: function () {
            return brushToString(this.i.bk);
        },
        set: function (v) {
            this.i.bk = stringToBrush(v);
            this._a("actualDescriptionTextColor", brushToString(this.i.bk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "descriptionCollapsedTextColor", {
        /**
         * Gets or sets the color to use for the header description text when the panel is collapsed.
        */
        get: function () {
            return brushToString(this.i.bx);
        },
        set: function (v) {
            this.i.bx = stringToBrush(v);
            this._a("descriptionCollapsedTextColor", brushToString(this.i.bx));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "descriptionExpandedTextColor", {
        /**
         * Gets or sets the color to use for the header description text when the panel is expanded.
        */
        get: function () {
            return brushToString(this.i.by);
        },
        set: function (v) {
            this.i.by = stringToBrush(v);
            this._a("descriptionExpandedTextColor", brushToString(this.i.by));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "elevation", {
        /**
         * Gets or sets the elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = +v;
            this._a("elevation", this.i.s);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualElevation", {
        /**
         * Gets or sets the elevation of the border shadow
        */
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = +v;
            this._a("actualElevation", this.i.q);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "expanded", {
        /**
         * Gets / sets the expanded state of the panel.
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = ensureBool(v);
            this._a("expanded", this.i.n);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "headerBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the header.
        */
        get: function () {
            return brushToString(this.i.b6);
        },
        set: function (v) {
            this.i.b6 = stringToBrush(v);
            this._a("headerBackgroundColor", brushToString(this.i.b6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualHeaderBackgroundColor", {
        /**
         * Gets or sets the color to use for the actual background of the header.
        */
        get: function () {
            return brushToString(this.i.bl);
        },
        set: function (v) {
            this.i.bl = stringToBrush(v);
            this._a("actualHeaderBackgroundColor", brushToString(this.i.bl));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "headerCollapsedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the header when the panel is expanded.
        */
        get: function () {
            return brushToString(this.i.b7);
        },
        set: function (v) {
            this.i.b7 = stringToBrush(v);
            this._a("headerCollapsedBackgroundColor", brushToString(this.i.b7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "headerExpandedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the header when the panel is expanded.
        */
        get: function () {
            return brushToString(this.i.b8);
        },
        set: function (v) {
            this.i.b8 = stringToBrush(v);
            this._a("headerExpandedBackgroundColor", brushToString(this.i.b8));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualUmbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.bn);
        },
        set: function (v) {
            this.i.bn = stringToBrush(v);
            this._a("actualUmbraShadowColor", brushToString(this.i.bn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualPenumbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.bm);
        },
        set: function (v) {
            this.i.bm = stringToBrush(v);
            this._a("actualPenumbraShadowColor", brushToString(this.i.bm));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "actualAmbientShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.bi);
        },
        set: function (v) {
            this.i.bi = stringToBrush(v);
            this._a("actualAmbientShadowColor", brushToString(this.i.bi));
        },
        enumerable: false,
        configurable: true
    });
    IgcXExpansionPanelComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgcXExpansionPanelComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgcXExpansionPanelComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("XExpansionPanelComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Collapses the contents of the expansion panel.

*/
    IgcXExpansionPanelComponent.prototype.collapse = function () {
        this.i.ar();
    };
    /**
     * Expands the contents of the expansion panel.
    
    */
    IgcXExpansionPanelComponent.prototype.expand = function () {
        this.i.au();
    };
    /**
     * Toggles the expanded state of the expansion panel.
    
    */
    IgcXExpansionPanelComponent.prototype.toggle = function () {
        this.i.a2();
    };
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "onCollapsed", {
        /**
         * Fires when the expansion panel is collapsed.
        */
        get: function () {
            return this._onCollapsed;
        },
        set: function (ev) {
            var _this = this;
            if (this._onCollapsed_wrapped !== null) {
                this.i.onCollapsed = delegateRemove(this.i.onCollapsed, this._onCollapsed_wrapped);
                this._onCollapsed_wrapped = null;
                this._onCollapsed = null;
            }
            this._onCollapsed = ev;
            this._onCollapsed_wrapped = function (o, e) {
                var outerArgs = new IgcOnCollapsedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeOnCollapsed) {
                    _this.beforeOnCollapsed(_this, outerArgs);
                }
                if (_this._onCollapsed) {
                    _this._onCollapsed(_this, outerArgs);
                }
            };
            this.i.onCollapsed = delegateCombine(this.i.onCollapsed, this._onCollapsed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXExpansionPanelComponent.prototype, "onExpanded", {
        get: function () {
            return this._onExpanded;
        },
        set: function (ev) {
            var _this = this;
            if (this._onExpanded_wrapped !== null) {
                this.i.onExpanded = delegateRemove(this.i.onExpanded, this._onExpanded_wrapped);
                this._onExpanded_wrapped = null;
                this._onExpanded = null;
            }
            this._onExpanded = ev;
            this._onExpanded_wrapped = function (o, e) {
                var outerArgs = new IgcOnExpandedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeOnExpanded) {
                    _this.beforeOnExpanded(_this, outerArgs);
                }
                if (_this._onExpanded) {
                    _this._onExpanded(_this, outerArgs);
                }
            };
            this.i.onExpanded = delegateCombine(this.i.onExpanded, this._onExpanded_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcXExpansionPanelComponent._observedAttributesIgcXExpansionPanelComponent = null;
    IgcXExpansionPanelComponent.htmlTagName = "igc-x-expansion-panel";
    IgcXExpansionPanelComponent._isElementRegistered = false;
    return IgcXExpansionPanelComponent;
}(IgcHTMLElement));
export { IgcXExpansionPanelComponent };
