import { Base, Type, INotifyPropertyChanged, EventArgs, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { INativeUIElementFactory } from "igniteui-webcomponents-core";
import { NativeUIElementFactoryFlavor } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { NativeUIComponentBuiltInType } from "igniteui-webcomponents-core";
import { DomWrapper, DomRenderer } from "igniteui-webcomponents-core";
import { XComponentBridge } from "igniteui-webcomponents-inputs";
import { INativeUIToolPanelBridge } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-webcomponents-core";
import { NativeUIBuiltInEvents } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { NativeUIBuiltInProperties } from "igniteui-webcomponents-core";
import { ToolPanelOrientation } from "./ToolPanelOrientation";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ListPanel } from "./ListPanel";
import { Popup } from "igniteui-webcomponents-core";
import { NativeUIContent } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { NativeUIContentRefreshedEventArgs } from "./NativeUIContentRefreshedEventArgs";
import { IExecutionContext } from "igniteui-webcomponents-core";
import { Visibility } from "igniteui-webcomponents-core";
import { ToolActionType } from "igniteui-webcomponents-core";
import { NativeUIGrid } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { ToolCommandArgument } from "igniteui-webcomponents-core";
import { NativeUIIcon } from "igniteui-webcomponents-core";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolCommand } from "igniteui-webcomponents-core";
import { ToolActionInfo } from "igniteui-webcomponents-core";
import { NativeUIButton } from "igniteui-webcomponents-core";
import { NativeUIButtonClickedEventArgs } from "igniteui-webcomponents-core";
import { NativeUIClickedEventArgs } from "igniteui-webcomponents-core";
import { NativeUIPopup } from "igniteui-webcomponents-core";
import { NativeUIMouseEventArgs } from "igniteui-webcomponents-core";
import { NativeUIFocusEventArgs } from "igniteui-webcomponents-core";
import { NestedActionMode } from "./NestedActionMode";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { NativeUIAbsolutePanel } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class NativeUILayoutFactory extends Base implements INativeUIElementFactory {
    static $t: Type;
    private static a;
    static get b(): NativeUILayoutFactory;
    static e(): void;
    private c;
    get flavor(): NativeUIElementFactoryFlavor;
    createComponent(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    createComponentSync(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    supportsComponent(a: NativeUIComponentBuiltInType): boolean;
    private d;
}
/**
 * @hidden
 */
export declare class XToolPanelBridge extends XComponentBridge implements INativeUIToolPanelBridge {
    static $t: Type;
    private u;
    private x;
    private v;
    private y;
    private w;
    private z;
    constructor(a: any);
    getDesiredSize(a: any, b: Size): Size;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    private ab;
    private ac;
    private aa;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    refresh(a: any): void;
    notifySizeChanged(a: any, b: Size): void;
}
/**
 * @hidden
 */
export declare class ToolPanelView extends Base {
    static $t: Type;
    private s;
    private r;
    constructor();
    v(): any;
    c: ToolPanel;
    ab(): void;
    n: DomRenderer;
    get t(): DomWrapper;
    q: DomWrapper;
    g: RenderingContext;
    p: DomWrapper;
    z(a: DomRenderer): void;
    ad(): void;
    y(): void;
    k(): number;
    j(): number;
    ae(): void;
    private d;
    private ag;
    private e;
    private _gridExternal;
    f(): FontInfo;
    aa(): void;
    ac(): void;
    x(): void;
    i(): number;
    l(a: string): number;
    m(a: string, b: FontInfo): number;
    h: boolean;
    private o;
    w(a: any, b: (arg1: any) => void): void;
    a(): Popup;
    b(a: NativeUIContent): ToolPanel;
    af(a: any): Rect;
}
/**
 * @hidden
 */
export declare class NativeUIToolPanel extends NativeUIComponent {
    static $t: Type;
    private get bk();
    get bp(): ToolActionCollection;
    set bp(a: ToolActionCollection);
    get bs(): number;
    set bs(a: number);
    get br(): number;
    get bq(): ToolPanelOrientation;
    set bq(a: ToolPanelOrientation);
    get b1(): Brush;
    set b1(a: Brush);
    get bw(): Brush;
    set bw(a: Brush);
    get bv(): Brush;
    set bv(a: Brush);
    get b0(): Brush;
    set b0(a: Brush);
    get bx(): Brush;
    set bx(a: Brush);
    get by(): Brush;
    set by(a: Brush);
    get bz(): Brush;
    set bz(a: Brush);
    private bl;
    get bm(): (sender: any, args: NativeUIContentRefreshedEventArgs) => void;
    set bm(a: (sender: any, args: NativeUIContentRefreshedEventArgs) => void);
    private bg;
    get bi(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bi(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bh;
    get bj(): (sender: any, e: DrillDownRequestedEventArgs) => void;
    set bj(a: (sender: any, e: DrillDownRequestedEventArgs) => void);
    private bn;
    get bo(): (sender: any, args: ToolCommandEventArgs) => void;
    set bo(a: (sender: any, args: ToolCommandEventArgs) => void);
    bu(): void;
    bt(a: Size): void;
}
/**
 * @hidden
 */
export declare abstract class ToolAction extends Base implements INotifyPropertyChanged {
    static $t: Type;
    j: ToolPanel;
    private a;
    get b(): IExecutionContext;
    set b(a: IExecutionContext);
    get cs(): string;
    d: ToolAction;
    private e;
    get actions(): ToolActionCollection;
    private a0;
    get bi(): number;
    set bi(a: number);
    constructor();
    dd(): void;
    private dq;
    private dr;
    private c5;
    g(a: boolean): ToolActionEventDetail;
    n(): ToolCommandArgument;
    c3(): string;
    bl(): any;
    bm(): any;
    private bs;
    get c1(): string;
    set c1(a: string);
    b9: string;
    b6: string;
    cw: string;
    c4(): string;
    private bo;
    get cd(): string;
    set cd(a: string);
    private bn;
    get ca(): string;
    set ca(a: string);
    private bj;
    get bk(): any;
    set bk(a: any);
    private k;
    get l(): BaseControlTheme;
    set l(a: BaseControlTheme);
    private aw;
    get be(): number;
    set be(a: number);
    private ao;
    get a2(): number;
    set a2(a: number);
    private ax;
    get bf(): number;
    set bf(a: number);
    private ap;
    get a3(): number;
    set a3(a: number);
    private av;
    get bd(): number;
    set bd(a: number);
    private an;
    get a1(): number;
    set a1(a: number);
    private ay;
    get bg(): number;
    set bg(a: number);
    private aq;
    get a4(): number;
    set a4(a: number);
    private ed;
    get eq(): Brush;
    set eq(a: Brush);
    private ek;
    get ew(): Brush;
    set ew(a: Brush);
    private ei;
    private eb;
    get eo(): Brush;
    set eo(a: Brush);
    private eh;
    get eu(): Brush;
    set eu(a: Brush);
    private eg;
    get et(): Brush;
    set et(a: Brush);
    private en;
    get ez(): Brush;
    set ez(a: Brush);
    private ec;
    get ep(): Brush;
    set ep(a: Brush);
    private ej;
    get ev(): Brush;
    set ev(a: Brush);
    private o;
    get r(): FontInfo;
    set r(a: FontInfo);
    private q;
    get t(): FontInfo;
    set t(a: FontInfo);
    private ab;
    get ah(): boolean;
    set ah(a: boolean);
    get ag(): boolean;
    private br;
    get cu(): string;
    set cu(a: string);
    private bu;
    get da(): string;
    set da(a: string);
    private bt;
    get c6(): string;
    set c6(a: string);
    private az;
    get bh(): number;
    set bh(a: number);
    private bq;
    get cl(): string;
    set cl(a: string);
    private bp;
    get ci(): string;
    set ci(a: string);
    private as;
    get ba(): number;
    set ba(a: number);
    private at;
    get bb(): number;
    set bb(a: number);
    private au;
    get bc(): number;
    set bc(a: number);
    private ar;
    get a9(): number;
    set a9(a: number);
    private el;
    get ex(): Brush;
    set ex(a: Brush);
    private ee;
    get er(): Brush;
    set er(a: Brush);
    private em;
    get ey(): Brush;
    set ey(a: Brush);
    private ef;
    get es(): Brush;
    set es(a: Brush);
    private e0;
    get e1(): Visibility;
    set e1(a: Visibility);
    protected get_ad(): boolean;
    protected get ad(): boolean;
    protected get_ae(): boolean;
    protected get ae(): boolean;
    protected get_ai(): boolean;
    protected get ai(): boolean;
    protected get_ak(): boolean;
    protected get ak(): boolean;
    protected get_ac(): boolean;
    protected get ac(): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected dx(a: string, b: any, c: any): void;
    protected get_m(): ToolActionType;
    get m(): ToolActionType;
    protected d4(a: string, b: any, c: any): void;
    private p;
    d9(): void;
    protected ea(): void;
    protected dw(): void;
    dz(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    d0(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    di(a: ToolPanel, b: ToolActionMeasurementContext): void;
    dj(a: ToolPanel, b: ToolActionMeasurementContext): void;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    a8(a: ToolPanel, b: ToolActionMeasurementContext): number;
    a6(a: ToolPanel, b: ToolActionMeasurementContext): number;
    s(a: ToolPanel): FontInfo;
    a5(a: ToolPanel, b: ToolActionMeasurementContext): number;
    dy(a: ToolActionEventDetail, b: ToolAction): void;
    private d5;
    protected d6(a: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    protected al(): boolean;
    private dg;
    af(): boolean;
    private dt;
    private dh;
    performed: (sender: any, args: ToolActionPerformedEventArgs) => void;
    static c(a: ToolActionInfo): ToolAction;
    dp(a: ToolActionInfo): void;
    protected aj(): boolean;
    protected am(): boolean;
    protected v(a: NativeUIComponentBuiltInType): NativeUIElementFactoryFlavor;
    private x;
    protected get y(): NativeUIGrid;
    private w;
    private u;
    private z;
    private aa;
    private dn;
    protected dm(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected dl(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected d8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private dk;
    private ds;
    private d7;
    protected de(a: NativeUIContent): void;
    protected dv(): void;
    protected du(a: any, b: NativeUIClickedEventArgs): void;
    d2(): void;
    df(): void;
    d3(a: ToolAction): void;
}
/**
 * @hidden
 */
export declare class ToolActionButton extends ToolAction {
    static $t: Type;
    protected get_m(): ToolActionType;
    n(): ToolCommandArgument;
    g(a: boolean): ToolActionEventDetail;
    private e2;
    a8(a: ToolPanel, b: ToolActionMeasurementContext): number;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private e4;
    private e3;
    d0(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionLabel extends ToolAction {
    static $t: Type;
    private static readonly e3;
    private e2;
    protected get_ad(): boolean;
    constructor();
    protected get_m(): ToolActionType;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private e4;
    protected dv(): void;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected d4(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class ToolActionRadio extends ToolAction {
    static $t: Type;
    private e2;
    protected get_m(): ToolActionType;
    private e5;
    get e6(): string;
    set e6(a: string);
    private e3;
    get e4(): boolean;
    set e4(a: boolean);
    g(a: boolean): ToolActionEventDetail;
    bm(): any;
    e8(): void;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected ea(): void;
    protected dv(): void;
    private e9;
    private fa;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected d4(a: string, b: any, c: any): void;
    dp(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionSeparator extends ToolAction {
    static $t: Type;
    private e4;
    get e5(): number;
    set e5(a: number);
    private e2;
    get e3(): boolean;
    set e3(a: boolean);
    constructor();
    protected get_m(): ToolActionType;
    dj(a: ToolPanel, b: ToolActionMeasurementContext): void;
    protected dm(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected dl(a: NativeUIGrid, b: ToolActionMeasurementContext): void;
    protected d8(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ea(): void;
    protected d4(a: string, b: any, c: any): void;
    dp(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconButton extends ToolAction {
    static $t: Type;
    private e7;
    private e3;
    private e2;
    private fh;
    private fi;
    private fd;
    private fa;
    private e9;
    protected get_m(): ToolActionType;
    protected get_ak(): boolean;
    protected get e8(): NativeUIPopup;
    protected get_fg(): boolean;
    protected get fg(): boolean;
    private fc;
    protected get ff(): boolean;
    protected set ff(a: boolean);
    private fj;
    get fk(): number;
    set fk(a: number);
    private fe;
    constructor();
    dd(): void;
    n(): ToolCommandArgument;
    g(a: boolean): ToolActionEventDetail;
    protected e4: NativeUIButton;
    protected e6: NativeUIIcon;
    protected e5: NativeUIIcon;
    a6(a: ToolPanel, b: ToolActionMeasurementContext): number;
    a8(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected dm(a: NativeUIContent, b: NativeUIGrid, c: ToolActionMeasurementContext, d: () => void): void;
    protected de(a: NativeUIContent): void;
    private f2;
    protected f3(a: NativeUIGrid, b: NativeUIPopup): void;
    protected fm(): void;
    protected fo(): void;
    protected fn(): void;
    protected fp(): void;
    private f0;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ea(): void;
    protected dw(): void;
    d2(): void;
    df(): void;
    protected f1(a?: boolean): void;
    protected fl(): void;
    private fv;
    private fq;
    protected ft(a: any, b: NativeUIMouseEventArgs): void;
    protected fu(a: any, b: NativeUIMouseEventArgs): void;
    protected fr(a: any, b: NativeUIButtonClickedEventArgs): void;
    private fb;
    private fy;
    private fz;
    private fw;
    private fx;
    protected fs(a: any, b: NativeUIFocusEventArgs): void;
    protected d4(a: string, b: any, c: any): void;
    dp(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionGroupHeader extends ToolAction {
    static $t: Type;
    private static readonly e5;
    private e2;
    private e3;
    protected get_m(): ToolActionType;
    protected get_ad(): boolean;
    protected get_ae(): boolean;
    protected get_ai(): boolean;
    private e9;
    get fb(): Brush;
    set fb(a: Brush);
    private fa;
    get fc(): Brush;
    set fc(a: Brush);
    constructor();
    s(a: ToolPanel): FontInfo;
    a5(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private e8;
    private e7;
    protected de(a: NativeUIContent): void;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ea(): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconMenu extends ToolActionIconButton {
    static $t: Type;
    private f4;
    protected get_m(): ToolActionType;
    protected get_fg(): boolean;
    protected fm(): void;
    protected fo(): void;
    protected fn(): void;
    protected fp(): void;
    private f6;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    private f5;
}
/**
 * @hidden
 */
export declare class ToolActionCheckbox extends ToolAction {
    static $t: Type;
    private e2;
    protected get_m(): ToolActionType;
    protected get_ac(): boolean;
    private e3;
    get e4(): boolean;
    set e4(a: boolean);
    g(a: boolean): ToolActionEventDetail;
    bm(): any;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected de(a: NativeUIContent): void;
    protected dv(): void;
    private e7;
    private e6;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ea(): void;
    protected d4(a: string, b: any, c: any): void;
    dp(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionNumberInput extends ToolAction {
    static $t: Type;
    private e2;
    protected get_m(): ToolActionType;
    private e3;
    get e5(): number;
    set e5(a: number);
    bm(): any;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): number;
    e4(): number;
    g(a: boolean): ToolActionEventDetail;
    private e7;
    private e8;
    d1(a: NativeUIGrid, b: ListPanelTemplateItemUpdatingEventArgs, c: ToolActionMeasurementContext): void;
    protected ea(): void;
    protected d4(a: string, b: any, c: any): void;
    protected dv(): void;
    dp(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionCollection extends ObservableCollection$1<ToolAction> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class ToolActionPerformedEventArgs extends Base {
    static $t: Type;
    constructor();
    c: boolean;
    a: ToolActionEventDetail;
    b: ToolActionEventDetailCollection;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetail extends Base {
    static $t: Type;
    a: ToolAction;
    b: ToolActionType;
    d: boolean;
    c: boolean;
    f: number;
    e: Date;
    g: any;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetailCollection extends ObservableCollection$1<ToolActionEventDetail> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ToolPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    p: ToolPanelView;
    v: NativeUIGrid;
    private y;
    private w;
    private get x();
    dh(a: ListPanel): void;
    private c4;
    private c5;
    private c6;
    private i;
    private c7;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private g;
    dm(a: Size): void;
    contentRefreshed: (sender: any, args: ToolPanelContentRefreshedEventArgs) => void;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private aa;
    get ac(): boolean;
    set ac(a: boolean);
    constructor();
    private c8;
    private c9;
    private dl;
    private z;
    protected du(): void;
    dw(): void;
    private de;
    private ae;
    private af;
    private ad;
    private da;
    ab(a: ToolAction): boolean;
    f(a: string): ToolAction;
    ag(a: ToolAction): List$1<ToolAction>;
    private j;
    private dq;
    private dj;
    private d0;
    fk(): Size;
    private df;
    dg(): void;
    dx(): void;
    dv(a: ToolAction): void;
    private di;
    private db;
    dr(): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private s;
    get t(): FontInfo;
    set t(a: FontInfo);
    u(): FontInfo;
    protected dn(a: string, b: any, c: any): void;
    protected ds(a: string, b: any, c: any): void;
    private d3;
    private d2;
    private d1;
    a: IExecutionContext;
    private q;
    get r(): BaseControlTheme;
    set r(a: BaseControlTheme);
    private eh;
    get e7(): Brush;
    set e7(a: Brush);
    private d4;
    get eu(): Brush;
    set eu(a: Brush);
    private eq;
    get fg(): Brush;
    set fg(a: Brush);
    private ed;
    get e3(): Brush;
    set e3(a: Brush);
    private ej;
    get e9(): Brush;
    set e9(a: Brush);
    private d6;
    get ew(): Brush;
    set ew(a: Brush);
    private ep;
    get ff(): Brush;
    set ff(a: Brush);
    private ec;
    get e2(): Brush;
    set e2(a: Brush);
    private ek;
    get fa(): Brush;
    set fa(a: Brush);
    static readonly bs: string;
    private d7;
    get ex(): Brush;
    set ex(a: Brush);
    private em;
    get fc(): Brush;
    set fc(a: Brush);
    private d9;
    get ez(): Brush;
    set ez(a: Brush);
    private d;
    private ar;
    er: Brush;
    get fh(): Brush;
    set fh(a: Brush);
    private ee;
    get e4(): Brush;
    set e4(a: Brush);
    ei: Brush;
    get e8(): Brush;
    set e8(a: Brush);
    private d5;
    get ev(): Brush;
    set ev(a: Brush);
    private el;
    get fb(): Brush;
    set fb(a: Brush);
    private d8;
    get ey(): Brush;
    set ey(a: Brush);
    private et;
    get fj(): Brush;
    set fj(a: Brush);
    private eg;
    get e6(): Brush;
    set e6(a: Brush);
    private es;
    get fi(): Brush;
    set fi(a: Brush);
    private ef;
    get e5(): Brush;
    set e5(a: Brush);
    private a0;
    get bl(): number;
    set bl(a: number);
    private ap;
    get bb(): number;
    set bb(a: number);
    private a1;
    get bm(): number;
    set bm(a: number);
    private aq;
    get bc(): number;
    set bc(a: number);
    private en;
    get fd(): Brush;
    set fd(a: Brush);
    private ea;
    get e0(): Brush;
    set e0(a: Brush);
    private eo;
    get fe(): Brush;
    set fe(a: Brush);
    private eb;
    get e1(): Brush;
    set e1(a: Brush);
    private ax;
    get bi(): number;
    set bi(a: number);
    private am;
    get a8(): number;
    set a8(a: number);
    private ay;
    get bj(): number;
    set bj(a: number);
    private an;
    get a9(): number;
    set a9(a: number);
    private az;
    get bk(): number;
    set bk(a: number);
    private ao;
    get ba(): number;
    set ba(a: number);
    private aw;
    get bh(): number;
    set bh(a: number);
    private al;
    get a7(): number;
    set a7(a: number);
    private at;
    get be(): number;
    set be(a: number);
    private ai;
    get a4(): number;
    set a4(a: number);
    private au;
    get bf(): number;
    set bf(a: number);
    private aj;
    get a5(): number;
    set a5(a: number);
    private av;
    get bg(): number;
    set bg(a: number);
    private ak;
    get a6(): number;
    set a6(a: number);
    private as;
    get bd(): number;
    set bd(a: number);
    private ah;
    get a3(): number;
    set a3(a: number);
    static n: ToolPanelOrientation;
    private m;
    get o(): ToolPanelOrientation;
    set o(a: ToolPanelOrientation);
    dp(a: ToolAction, b: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    get bn(): number;
    set bn(a: number);
    get a2(): number;
    e: NestedActionMode;
    drillDownRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    drillUpRequested: (sender: any, e: DrillDownRequestedEventArgs) => void;
    dy(a: ToolAction): void;
    dz(a: ToolAction): void;
    dc(): void;
}
/**
 * @hidden
 */
export declare class DrillDownRequestedEventArgs extends Base {
    static $t: Type;
    a: ToolAction;
}
/**
 * @hidden
 */
export declare class ToolPanelsPresenter extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private ab;
    private i;
    private j;
    private y;
    private o;
    private a;
    private d;
    private g;
    private ay;
    private az;
    private p;
    private b;
    private e;
    private h;
    private c;
    private f;
    private w;
    private get a0();
    private set a0(value);
    private get a1();
    private set a1(value);
    r: NativeUIGrid;
    q: NativeUIAbsolutePanel;
    private u;
    get v(): List$1<PanelInfo>;
    private m;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    private x;
    get z(): number;
    set z(a: number);
    s: (arg1: ToolCommandEventArgs) => void;
    private aa;
    constructor(a: any, b: IExecutionContext);
    ai(a: () => void): void;
    ae(a: ToolAction, b?: (arg1: NativeUIToolPanel) => void): void;
    aj(a: NativeUIToolPanel): void;
    al(a: number): void;
    ak(a: PanelInfo, b?: () => void): void;
    private aq;
    private ar;
    private ao;
    private af;
    private ah;
    private an;
    private t;
    av(): void;
    private ag;
    aw(): void;
    ax(a: BaseControlTheme, b: ToolPanel): void;
    am(): void;
    containerReady: (sender: any) => void;
    private ap;
    sizeChanged: (sender: any) => void;
    private at;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private as;
    protected au(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class PanelInfo extends Base {
    static $t: Type;
    c: number;
    a: NativeUIToolPanel;
    b: ToolAction;
    constructor(a: ToolAction, b: NativeUIToolPanel, c: number);
    f(): Size;
    e(): void;
    d(a: Size): void;
}
/**
 * @hidden
 */
export declare class PanelAnimationRequest extends Base {
    static $t: Type;
    a: PanelInfo;
    c: number;
    b: () => void;
}
