import { ListPanel } from "./ListPanel";
import { IDataSource } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcListPanelTemplateItemUpdatingEventArgs } from './igc-list-panel-template-item-updating-event-args';
import { ListPanelOrientation } from './ListPanelOrientation';
import { IgcListPanelContentRefreshedEventArgs } from './igc-list-panel-content-refreshed-event-args';
import { IgcListPanelTemplateWidthRequestedEventArgs } from './igc-list-panel-template-width-requested-event-args';
import { IgcListPanelTemplateHeightRequestedEventArgs } from './igc-list-panel-template-height-requested-event-args';
import { IExternalListPanel } from './IExternalListPanel';
export declare class IgcListPanelComponent extends IgcHTMLElement implements IExternalListPanel {
    private _implementation;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    createLocalDataSource(itemsSource: any): IDataSource;
    onContentSizeChanged(): void;
    private _webComponentWrapper;
    private _webComponentRenderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): ListPanel;
    get i(): ListPanel;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    private _dataSource;
    set dataSource(value: any);
    get dataSource(): any;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcListPanelComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get rowHeight(): number;
    set rowHeight(v: number);
    get actualRowHeight(): number;
    set actualRowHeight(v: number);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    get hasUnevenSizes(): boolean;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ListPanelOrientation;
    set orientation(v: ListPanelOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get isCustomRowHeightEnabled(): boolean;
    set isCustomRowHeightEnabled(v: boolean);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Gets the last visible index in the grid.

*/
    getLastVisibleIndex(): number;
    /**
     * Gets the first visible index in the grid.
    
    */
    getFirstVisibleIndex(): number;
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    invalidateVisibleItems(): void;
    notifySetItem(index: number, oldItem: any, newItem: any): void;
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems(): void;
    notifyInsertItem(index: number, newItem: any): void;
    notifyRemoveItem(index: number, oldItem: any): void;
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    dataIndexOfItem(item: any): number;
    dataIndexOfPrimaryKey(key: any[]): number;
    private _contentRefreshed;
    private _contentRefreshed_wrapped;
    get contentRefreshed(): (s: IgcListPanelComponent, e: IgcListPanelContentRefreshedEventArgs) => void;
    set contentRefreshed(ev: (s: IgcListPanelComponent, e: IgcListPanelContentRefreshedEventArgs) => void);
    private _rowUpdating;
    private _rowUpdating_wrapped;
    get rowUpdating(): (s: IgcListPanelComponent, e: IgcListPanelTemplateItemUpdatingEventArgs) => void;
    set rowUpdating(ev: (s: IgcListPanelComponent, e: IgcListPanelTemplateItemUpdatingEventArgs) => void);
    private _itemWidthRequested;
    private _itemWidthRequested_wrapped;
    get itemWidthRequested(): (s: IgcListPanelComponent, e: IgcListPanelTemplateWidthRequestedEventArgs) => void;
    set itemWidthRequested(ev: (s: IgcListPanelComponent, e: IgcListPanelTemplateWidthRequestedEventArgs) => void);
    private _itemHeightRequested;
    private _itemHeightRequested_wrapped;
    get itemHeightRequested(): (s: IgcListPanelComponent, e: IgcListPanelTemplateHeightRequestedEventArgs) => void;
    set itemHeightRequested(ev: (s: IgcListPanelComponent, e: IgcListPanelTemplateHeightRequestedEventArgs) => void);
}
