import { PropertyEditorPanel } from "./PropertyEditorPanel";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { ComponentRenderer } from "igniteui-webcomponents-core";
import { TypeDescriptionContext } from "igniteui-webcomponents-core";
import { IgcPropertyEditorPropertyDescriptionCollection } from './igc-property-editor-property-description-collection';
import { IgcPropertyEditorPropertyDescriptionComponent } from './igc-property-editor-property-description-component';
export declare class IgcPropertyEditorPanelComponent extends IgcHTMLElement {
    private _implementation;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _webComponentWrapper;
    private _webComponentRenderer;
    private _portalManager;
    contentProperties: IgcPropertyEditorPropertyDescriptionComponent[];
    /**
    * The properties actually present in the editor. Do not directly modify this array.
    * This array's contents can be modified by using the properties property or providing child content.
    */
    actualProperties: IgcPropertyEditorPropertyDescriptionComponent[];
    private _properties;
    private _propertiesAdapter;
    /**
     * A collection of manually added properties for the editor.
    */
    get properties(): IgcPropertyEditorPropertyDescriptionCollection;
    constructor();
    updateStyle(): void;
    destroy(): void;
    private updateContentProperties;
    protected createImplementation(): PropertyEditorPanel;
    get i(): PropertyEditorPanel;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcPropertyEditorPanelComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    private _actualDataSource;
    /**
     * Gets the actaul data or data source instance to which to bind the grid.
    */
    get actualDataSource(): IgcPropertyEditorPropertyDescriptionCollection;
    set actualDataSource(v: IgcPropertyEditorPropertyDescriptionCollection);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get rowHeight(): number;
    set rowHeight(v: number);
    get actualRowHeight(): number;
    set actualRowHeight(v: number);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    get actualDescriptionContext(): TypeDescriptionContext;
    set actualDescriptionContext(v: TypeDescriptionContext);
    get descriptionContext(): TypeDescriptionContext;
    set descriptionContext(v: TypeDescriptionContext);
    get componentRenderer(): ComponentRenderer;
    set componentRenderer(v: ComponentRenderer);
    get target(): any;
    set target(v: any);
    get descriptionType(): string;
    set descriptionType(v: string);
    get isHorizontal(): boolean;
    set isHorizontal(v: boolean);
    get isWrappingEnabled(): boolean;
    set isWrappingEnabled(v: boolean);
    get isIndirectModeEnabled(): boolean;
    set isIndirectModeEnabled(v: boolean);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    notifySetItem(index: number, oldItem: any, newItem: any): void;
    /**
     * Manually notifies the checkboxlist's grid that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems(): void;
    notifyInsertItem(index: number, newItem: any): void;
    notifyRemoveItem(index: number, oldItem: any): void;
}
