import { IgSize } from "igniteui-webcomponents-core";
import { ToolPanel } from "./ToolPanel";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { ToolPanelOrientation } from './ToolPanelOrientation';
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { IgcToolActionCollection } from "./igc-tool-action-collection";
import { IgcToolPanelContentRefreshedEventArgs } from "./igc-tool-panel-content-refreshed-event-args";
import { IgcToolCommandEventArgs } from './igc-tool-command-event-args';
import { NestedActionMode } from './NestedActionMode';
export declare class IgcToolPanelComponent extends IgcHTMLElement {
    private _implementation;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _webComponentWrapper;
    private _webComponentRenderer;
    private _portalManager;
    contentActions: IgcToolActionComponent[];
    /**
    * The actions actually present in the editor. Do not directly modify this array.
    * This array's contents can be modified by using the actions property or providing child content.
    */
    actualActions: IgcToolActionComponent[];
    private _actions;
    private _actionsAdapter;
    /**
     * A collection of manually added actions for the editor.
    */
    get actions(): IgcToolActionCollection;
    constructor();
    updateStyle(): void;
    destroy(): void;
    private updateContentProperties;
    protected createImplementation(): ToolPanel;
    get i(): ToolPanel;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcToolPanelComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets if the tool actions should display their submenus on mouse hover.
*/
    get showOnHover(): boolean;
    set showOnHover(v: boolean);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    get actualBackgroundColor(): string;
    set actualBackgroundColor(v: string);
    /**
     * Gets or sets the background color for submenus.
    */
    get submenuBackgroundColor(): string;
    set submenuBackgroundColor(v: string);
    get actualSubmenuBackgroundColor(): string;
    set actualSubmenuBackgroundColor(v: string);
    /**
     * Gets or sets the group header background color.
    */
    get groupHeaderBackgroundColor(): string;
    set groupHeaderBackgroundColor(v: string);
    get actualGroupHeaderBackgroundColor(): string;
    set actualGroupHeaderBackgroundColor(v: string);
    /**
     * Gets or sets the separator background color.
    */
    get separatorBackgroundColor(): string;
    set separatorBackgroundColor(v: string);
    get actualSeparatorBackgroundColor(): string;
    set actualSeparatorBackgroundColor(v: string);
    /**
     * Gets or sets the group header separator background color.
    */
    get groupHeaderSeparatorBackgroundColor(): string;
    set groupHeaderSeparatorBackgroundColor(v: string);
    get actualGroupHeaderSeparatorBackgroundColor(): string;
    set actualGroupHeaderSeparatorBackgroundColor(v: string);
    /**
     * Gets or sets the hover background color.
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    get actualHoverBackgroundColor(): string;
    set actualHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets or sets the color to use for the text in disabled tool actions.
    */
    get disabledTextColor(): string;
    set disabledTextColor(v: string);
    get actualDisabledTextColor(): string;
    set actualDisabledTextColor(v: string);
    /**
     * Gets or sets the text color for group header tool actions.
    */
    get groupHeaderTextColor(): string;
    set groupHeaderTextColor(v: string);
    get actualGroupHeaderTextColor(): string;
    set actualGroupHeaderTextColor(v: string);
    /**
     * Gets or sets the tooltip text color.
    */
    get toolTipTextColor(): string;
    set toolTipTextColor(v: string);
    get actualToolTipTextColor(): string;
    set actualToolTipTextColor(v: string);
    /**
     * Gets or sets the tooltip background color.
    */
    get toolTipBackgroundColor(): string;
    set toolTipBackgroundColor(v: string);
    /**
     * Gets the actual tooltip background color.
    */
    get actualToolTipBackgroundColor(): string;
    set actualToolTipBackgroundColor(v: string);
    /**
     * Gets or sets the tooltip corner radius.
    */
    get toolTipCornerRadius(): number;
    set toolTipCornerRadius(v: number);
    /**
     * Gets the actual tooltip corner radius.
    */
    get actualToolTipCornerRadius(): number;
    set actualToolTipCornerRadius(v: number);
    /**
     * Gets or sets the shadow elevation for the tooltip.
    */
    get toolTipElevation(): number;
    set toolTipElevation(v: number);
    /**
     * Gets the actual shadow elevation used by the tooltip.
    */
    get actualToolTipElevation(): number;
    set actualToolTipElevation(v: number);
    /**
     * Gets or sets the fill color of icons in the ToolPanel.
    */
    get iconFill(): string;
    set iconFill(v: string);
    /**
     * Gets the actual icon fill color.
    */
    get actualIconFill(): string;
    set actualIconFill(v: string);
    /**
     * Gets or sets the stroke color of icons in the ToolPanel.
    */
    get iconStroke(): string;
    set iconStroke(v: string);
    /**
     * Gets the actual icon stroke color.
    */
    get actualIconStroke(): string;
    set actualIconStroke(v: string);
    /**
     * Gets or sets the left padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingLeft(): number;
    set separatorVerticalPaddingLeft(v: number);
    get actualSeparatorVerticalPaddingLeft(): number;
    set actualSeparatorVerticalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingRight(): number;
    set separatorVerticalPaddingRight(v: number);
    get actualSeparatorVerticalPaddingRight(): number;
    set actualSeparatorVerticalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingTop(): number;
    set separatorVerticalPaddingTop(v: number);
    get actualSeparatorVerticalPaddingTop(): number;
    set actualSeparatorVerticalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingBottom(): number;
    set separatorVerticalPaddingBottom(v: number);
    get actualSeparatorVerticalPaddingBottom(): number;
    set actualSeparatorVerticalPaddingBottom(v: number);
    /**
     * Gets or sets the left padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingLeft(): number;
    set separatorHorizontalPaddingLeft(v: number);
    get actualSeparatorHorizontalPaddingLeft(): number;
    set actualSeparatorHorizontalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingRight(): number;
    set separatorHorizontalPaddingRight(v: number);
    get actualSeparatorHorizontalPaddingRight(): number;
    set actualSeparatorHorizontalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingTop(): number;
    set separatorHorizontalPaddingTop(v: number);
    get actualSeparatorHorizontalPaddingTop(): number;
    set actualSeparatorHorizontalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingBottom(): number;
    set separatorHorizontalPaddingBottom(v: number);
    get actualSeparatorHorizontalPaddingBottom(): number;
    set actualSeparatorHorizontalPaddingBottom(v: number);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ToolPanelOrientation;
    set orientation(v: ToolPanelOrientation);
    /**
     * Gets or sets the row height for the panel.
    */
    get rowHeight(): number;
    set rowHeight(v: number);
    /**
     * Gets the actual row height used by the panel.
    */
    get actualRowHeight(): number;
    /**
     * Gets or sets the mode used when displaying nested actions.
    */
    get nestedActionMode(): NestedActionMode;
    set nestedActionMode(v: NestedActionMode);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    refresh(): void;
    getDesiredSize(): IgSize;
    /**
     * Forces any open sub menus to close.
    
    */
    closeSubmenus(): void;
    private _contentRefreshed;
    private _contentRefreshed_wrapped;
    get contentRefreshed(): (s: IgcToolPanelComponent, e: IgcToolPanelContentRefreshedEventArgs) => void;
    set contentRefreshed(ev: (s: IgcToolPanelComponent, e: IgcToolPanelContentRefreshedEventArgs) => void);
    private _onCommand;
    private _onCommand_wrapped;
    get onCommand(): (s: IgcToolPanelComponent, e: IgcToolCommandEventArgs) => void;
    set onCommand(ev: (s: IgcToolPanelComponent, e: IgcToolCommandEventArgs) => void);
}
