import { Toolbar } from "./Toolbar";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { ToolbarOrientation } from './ToolbarOrientation';
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { IgcToolActionCollection } from "./igc-tool-action-collection";
import { IgcToolCommandEventArgs } from './igc-tool-command-event-args';
import { ToolCommandStateType } from "igniteui-webcomponents-core";
export declare class IgcToolbarComponent extends IgcHTMLElement {
    private _implementation;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _webComponentWrapper;
    private _webComponentRenderer;
    private _portalManager;
    contentActions: IgcToolActionComponent[];
    /**
    * The actions actually present in the editor. Do not directly modify this array.
    * This array's contents can be modified by using the actions property or providing child content.
    */
    combinedActions: IgcToolActionComponent[];
    private _actions;
    private _actionsAdapter;
    /**
     * A collection of manually added actions for the editor.
    */
    get actions(): IgcToolActionCollection;
    constructor();
    updateStyle(): void;
    destroy(): void;
    private updateContentProperties;
    protected createImplementation(): Toolbar;
    get i(): Toolbar;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    /**
     * Gets or sets a target component which the toolbar can request actions from.
     */
    get target(): any;
    set target(v: any);
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcToolbarComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    private _autoGeneratedActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get autoGeneratedActions(): IgcToolActionCollection;
    set autoGeneratedActions(v: IgcToolActionCollection);
    private _actualActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get actualActions(): IgcToolActionCollection;
    set actualActions(v: IgcToolActionCollection);
    /**
     * Gets or sets the orientation of the toolbar.
    */
    get orientation(): ToolbarOrientation;
    set orientation(v: ToolbarOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the background color for submenus.
    */
    get submenuBackgroundColor(): string;
    set submenuBackgroundColor(v: string);
    /**
     * Gets or sets the group header background color.
    */
    get groupHeaderBackgroundColor(): string;
    set groupHeaderBackgroundColor(v: string);
    /**
     * Gets or sets the separator background color.
    */
    get separatorBackgroundColor(): string;
    set separatorBackgroundColor(v: string);
    /**
     * Gets or sets the hover background color.
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the text in disabled tool actions.
    */
    get disabledTextColor(): string;
    set disabledTextColor(v: string);
    /**
     * Gets or sets the text color for group header tool actions.
    */
    get groupHeaderTextColor(): string;
    set groupHeaderTextColor(v: string);
    /**
     * Gets or sets the tooltip text color.
    */
    get toolTipTextColor(): string;
    set toolTipTextColor(v: string);
    /**
     * Gets or sets the tooltip background color.
    */
    get toolTipBackgroundColor(): string;
    set toolTipBackgroundColor(v: string);
    /**
     * Gets or sets the tooltip corner radius.
    */
    get toolTipCornerRadius(): number;
    set toolTipCornerRadius(v: number);
    /**
     * Gets or sets the shadow elevation for the tooltip.
    */
    get toolTipElevation(): number;
    set toolTipElevation(v: number);
    /**
     * Gets or sets the fill color of icons in the ToolPanel.
    */
    get iconFill(): string;
    set iconFill(v: string);
    /**
     * Gets or sets the stroke color of icons in the ToolPanel.
    */
    get iconStroke(): string;
    set iconStroke(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    /**
     * Gets or sets the left padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingLeft(): number;
    set separatorVerticalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingRight(): number;
    set separatorVerticalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingTop(): number;
    set separatorVerticalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the vertical orientation.
    */
    get separatorVerticalPaddingBottom(): number;
    set separatorVerticalPaddingBottom(v: number);
    /**
     * Gets or sets the left padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingLeft(): number;
    set separatorHorizontalPaddingLeft(v: number);
    /**
     * Gets or sets the right padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingRight(): number;
    set separatorHorizontalPaddingRight(v: number);
    /**
     * Gets or sets the top padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingTop(): number;
    set separatorHorizontalPaddingTop(v: number);
    /**
     * Gets or sets the bottom padding for separators in the horizontal orientation.
    */
    get separatorHorizontalPaddingBottom(): number;
    set separatorHorizontalPaddingBottom(v: number);
    /**
     * Gets or sets if the tool actions should display their submenus on mouse hover.
    */
    get showOnHover(): boolean;
    set showOnHover(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Forces any open sub menus to close.

*/
    closeSubmenus(): void;
    onCommandStateChanged(id: string, type: ToolCommandStateType, value: any): void;
    registerIconFromText(iconCollection: string, iconName: string, iconText: string): void;
    getIconFromCache(iconCollection: string, iconName: string): string;
    private _onCommand;
    private _onCommand_wrapped;
    /**
     * Event raised when a command is triggered in the toolbar.
    */
    get onCommand(): (s: IgcToolbarComponent, e: IgcToolCommandEventArgs) => void;
    set onCommand(ev: (s: IgcToolbarComponent, e: IgcToolCommandEventArgs) => void);
}
